function [x,y,typ] = AMAZING_rollers(job,arg1,arg2)
  x=[];y=[];typ=[];
  select job
  case 'plot' then
    //exprs=arg1.graphics.exprs;
    //axis = exprs(1)
    standard_draw(arg1)
  case 'getinputs' then
    [x,y,typ]=standard_inputs(arg1)
  case 'getoutputs' then
    [x,y,typ]=standard_outputs(arg1)
  case 'getorigin' then
    [x,y]=standard_origin(arg1)
  case 'set' then
    x = arg1;
    model = arg1.model;
    graphics = arg1.graphics;
    exprs = graphics.exprs;
    while %t do
	   [ok,axis1,axis2,axis3,axis4,axis5,axis6,exprs] = getvalue('PID controllers tuning (please, insert the configuration parameters of the rollers)',..
	   ['KPx[max,step,value]:';'TIx[max,step,value]:';'TDx[max,step,value]:';'KPy[max,step,value]:';'TIy[max,step,value]:';'TDy[max,step,value]:'],..
	   list('vec',3,'vec',3,'vec',3,'vec',3,'vec',3,'vec',3),exprs)
      if ~ok then break,end
      //if(axis~='X' & axis~='Y') then 
      //warning('Accepted axis values are in [X,Y]. Keeping previous values.');
      //break
      //end
      in = [];
      out = 7;//if exists('outport') then out=ones(outport,1), else out=1, end
	  [model,graphics,ok] = check_io(model,graphics,in,out,1,[])
      if ok then
        graphics.exprs = exprs;
        model.rpar = [axis1;axis2;axis3;axis4;axis5;axis6];
        model.ipar = [];
        model.dstate = [];
        x.graphics = graphics;
        x.model = model;
        break
      end
    end
  case 'define' then
    axis1 = [10;0.001;1];
    axis2 = [10;0.001;1];
    axis3 = [10;0.001;1];
    axis4 = [10;0.001;1];
    axis5 = [10;0.001;1];
    axis6 = [10;0.001;1];
    model = scicos_model();
    model.sim = list('EvidenceAmazingRollers',4);
    model.in = [];
    model.out = 7;  //if exists('outport') then model.out=ones(outport,1), else model.out=1, end
    model.evtin = 1;
    model.rpar = [axis1;axis2;axis3;axis4;axis5;axis6];
    model.ipar = [];
    model.dstate = [];
    model.blocktype = 'd';
    model.dep_ut = [%t %f];
    exprs = ['[10;0.001;1]';'[10;0.001;1]';'[10;0.001;1]';'[10;0.001;1]';'[10;0.001;1]';'[10;0.001;1]'];	
    gr_i = ['xstringb(orig(1),orig(2),..
         [''AMAZING'';''PID TUNING''],..
	  sz(1),sz(2),''fill'');'];
    x = standard_define([3 2],model,exprs,gr_i)
  end
endfunction

